import { Client }                     from '@elastic/elasticsearch';
import { Inject }                     from '@nestjs/common';
import { ElasticsearchLoggerOptions } from './ElasticsearchLoggerOptions';

export class ElasticsearchLoggerService {

    private readonly client: Client;

    public constructor(@Inject('CONFIG_OPTIONS') private readonly options: ElasticsearchLoggerOptions) {

        console.log(options);

        this.client = new Client(options.elasticsearchClientOptions);

    }

    private log(level: string, args): void {

        this.client.index({

            index: this.options.index,
            body: args

        });

    }

    public info(...args): void {

        console.log(args);

        this.log('info', args);

    }

}
